unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Printers, BarImage, Menus, ShellAPI, Param,
  jpeg, Clipbrd, DropSource, DropTarget, DropMetaSource, DropBMPSource;

var
  CF_JFIF: Word;

type
  TPercent = 0..100; // p[Ze[W\킷ꍇ̐l(0% ` 100%)

  TDoubleSize = record
    Width: Double;
    Height: Double;
  end;

  TIntegerSize = record
    Width: Integer;
    Height: Integer;
  end;

  TPageInfo = record
    Size: Integer; // y[WTCY(oCg)
    Line: Integer; // y[W̍s
  end;

  {  }
  TPaperInfo = record
    PrintableArea: TIntegerSize;      // \̈̃TCY
    MMPrintableArea: TDoubleSize;     // \̈̃TCY(mm)
    PaperSize: TIntegerSize;          // TCY
    MMPaperSize: TDoubleSize;         // TCY(mm)
    DPI: TSize;                       // DPIl
    LeftMargin: Integer;              // ]
    TopMargin: Integer;
    RightMargin: Integer;
    BottomMargin: Integer;
    PILeftMargin: TPercent;           // ]1C`%l
    PITopMargin: TPercent;
    PIRightMargin: TPercent;
    PIBottomMargin: TPercent;
    MMLeftMargin: Double;             // ](mm)
    MMTopMargin: Double;
    MMRightMargin: Double;
    MMBottomMargin: Double;
    ScaleFactor: Integer;             // XP[t@N^(%)
    TrueMMPrintableArea: TDoubleSize; // ^̈\̈̃TCY(mm)
    TrueMMPaperSize: TDoubleSize;     // ^̎TCY(mm)
    TrueMMLeftMargin: Double;         // ^̗](mm)
    TrueMMTopMargin: Double;
    TrueMMRightMargin: Double;
    TrueMMBottomMargin: Double;
  end;

type
  TFrameForm = class(TForm)
    ScrollBox1: TScrollBox;
    BarImage1: TBarImage;
    ColorDialog1: TColorDialog;
    SaveDialog1: TSaveDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    FontDialog1: TFontDialog;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    CheckBox2: TCheckBox;
    Label5: TLabel;
    ComboBox1: TComboBox;
    ComboBox3: TComboBox;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    Label6: TLabel;
    ComboBox2: TComboBox;
    ComboBox4: TComboBox;
    Label12: TLabel;
    ComboBox7: TComboBox;
    Label14: TLabel;
    Edit6: TEdit;
    UpDown6: TUpDown;
    Button7: TButton;
    Button1: TButton;
    Button2: TButton;
    Button11: TButton;
    Label17: TLabel;
    ComboBox8: TComboBox;
    Label7: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label3: TLabel;
    ComboBox5: TComboBox;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Edit4: TEdit;
    UpDown4: TUpDown;
    Label8: TLabel;
    Label10: TLabel;
    Label4: TLabel;
    Label13: TLabel;
    ComboBox6: TComboBox;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Edit5: TEdit;
    UpDown5: TUpDown;
    Button3: TButton;
    Button12: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Panel5: TPanel;
    Panel6: TPanel;
    Memo1: TMemo;
    Button8: TButton;
    Edit7: TEdit;
    UpDown7: TUpDown;
    Label15: TLabel;
    Button10: TButton;
    Button9: TButton;
    Edit8: TEdit;
    UpDown8: TUpDown;
    Label16: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    UpDown9: TUpDown;
    UpDown10: TUpDown;
    Label18: TLabel;
    Label19: TLabel;
    CheckBox3: TCheckBox;
    Panel1: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    UpDown11: TUpDown;
    Button13: TButton;
    PopupMenu1: TPopupMenu;
    T1: TMenuItem;
    N1: TMenuItem;
    Help1: TMenuItem;
    N01: TMenuItem;
    N901: TMenuItem;
    N1801: TMenuItem;
    N2701: TMenuItem;
    N2: TMenuItem;
    CtrlF51: TMenuItem;
    Parameter1: TParameter;
    Button14: TButton;
    N4: TMenuItem;
    DropTextTarget1: TDropTextTarget;
    DropTextTarget2: TDropTextTarget;
    DropBMPSource1: TDropBMPSource;
    DropMetaSource1: TDropMetaSource;
    N3: TMenuItem;
    Panel9: TPanel;
    Panel10: TPanel;
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit3KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDown3Click(Sender: TObject; Button: TUDBtnType);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure ComboBox6Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure CheckBox2Click(Sender: TObject);
    procedure Edit5KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDown5Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit4KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDown4Click(Sender: TObject; Button: TUDBtnType);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Edit6KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDown6Click(Sender: TObject; Button: TUDBtnType);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure ComboBox7Change(Sender: TObject);
    procedure ComboBox7KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox8Change(Sender: TObject);
    procedure ComboBox8KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button12Click(Sender: TObject);
    procedure UpDown8Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown9Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown10Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit9KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit10KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBox3Click(Sender: TObject);
    procedure Panel7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UpDown11Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown11MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button13Click(Sender: TObject);
    procedure BarImage1ChangedCode(Sender: TObject; Watch: Boolean);
    procedure N01Click(Sender: TObject);
    procedure N901Click(Sender: TObject);
    procedure N1801Click(Sender: TObject);
    procedure N2701Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure CtrlF51Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DropTextTarget1Drop(Sender: TObject; ShiftState: TShiftState;
      Point: TPoint; var Effect: Integer);
    procedure DropTextTarget2Drop(Sender: TObject; ShiftState: TShiftState;
      Point: TPoint; var Effect: Integer);
    procedure BarImage1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BarImage1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure N3Click(Sender: TObject);
    procedure Panel9MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    OrgHeight: Integer;
    OldIndex: Integer;
    DragPoint: TPoint;
    procedure ExchangeItems(I, J: Integer);
    function SCompare(I, J: Integer): Integer;
    procedure QuickSort(L, R: Integer);
    function Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
  public
    { Public 錾 }
    pxi, pyi: Integer;              // v^̂PC`̃sNZ
    sxi, syi: Integer;              // XN[̂PC`̃sNZ
    ppwidth, ppheight: Integer;     // v^p̑傫(sNZP)
    leftmargin, topmargin: Integer; // v^p̍Ə̗](sNZP)
    pwidth, pheight: Integer;       // v^p̈\̈̑傫(sNZP)
    startx, starty: Integer;        // v^p̈\̈ɂJn_(sNZP)
    gapwidth, gapheight: Integer;   // ̗ԊuyэsԊu(sNZP)
    plist: Boolean;                 // Xgǂ̃XCb`
    nlist: Integer;                 // Xg̏ꍇ̈\ȃo[R[h̐
    slist: Boolean;                 // {̏Ԃ̎ true ɃZbg܂B
    PaperInfo: TPaperInfo;          // 
    SortBox: TComboBox;
    SortOrder: Integer;
    SaveDir: String;
    procedure DispFrom(bartype: Integer);
    procedure DispCheck;
    function CollectPaperInfo: TPaperInfo;
  end;

var
  FrameForm: TFrameForm;

implementation

uses Preview, Sort, DataList, BarSize;

{$R *.DFM}

procedure TFrameForm.FormShow(Sender: TObject);
var
  err1, err2, godisp: Boolean;
  i, j, p, len: Integer;
  FileName: String;
begin
  BarImage1.BarEnabled := False;
  FileName := Application.ExeName;
  FileName := ExtractFilePath(FileName);

  Memo1.Lines.LoadFromFile(FileName + 'Readme.txt');

  err1 := False;
  err2 := False;
  godisp := False;

  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB

  if Parameter1.Count = 0 then // p[^̃[hɎsꍇ
    err1 := True;

  try
    ComboBox1.Items.LoadFromFile(FileName + 'BarKun.txt');
  except
    err2 := True;
  end;

  if (err2 = False) and (ComboBox1.Items.Count = 0) then
    err2 := True;

  if err1 = False then
  begin
    Left := Parameter1['Left'];
    Top := Parameter1['Top'];
    Width := Parameter1['Width'];
    Height := Parameter1['Height'];
    WindowState := TWindowState(Parameter1['WindowState']);
    ComboBox2.ItemIndex := Parameter1['o[R[h̎'];
    BarImage1.BarType := TBarTypes(ComboBox2.ItemIndex);
    ComboBox3.ItemIndex := Parameter1['X^[gLN^'];
    BarImage1.StartChar := Char(Integer('A') + ComboBox3.ItemIndex);
    ComboBox4.ItemIndex := Parameter1['XgbvLN^'];
    BarImage1.StopChar := Char(Integer('A') + ComboBox4.ItemIndex);
    CheckBox2.Checked := Parameter1.VBools['\'];
    BarImage1.SymbolDisp := CheckBox2.Checked;
    CheckBox1.Checked := Parameter1.VBools['`FbNfWbg'];
    BarImage1.CD := CheckBox1.Checked;
    CheckBox3.Checked := Parameter1.VBools['Nbv{[hĎ'];
    BarImage1.ClipWatch := CheckBox3.Checked;
    UpDown1.Position := Parameter1['XP['];
    BarImage1.Scale := TSCale(UpDown1.Position);
    UpDown6.Position := Parameter1['ITFt['];
    BarImage1.BarFrame := TFrameSize(UpDown6.Position);
    ComboBox5.ItemIndex := Parameter1['\`'];
    UpDown2.Position := Parameter1[''];
    BarImage1.BarHeight := UpDown2.Position;
    UpDown9.Position := Parameter1['̗]'];
    BarImage1.BarSpaceUp := UpDown9.Position;
    UpDown10.Position := Parameter1['̗]'];
    BarImage1.BarSpaceDown := UpDown10.Position;
    UpDown4.Position := Parameter1['̗]'];
    BarImage1.BarSpaceLeft := UpDown4.Position;
    UpDown5.Position := Parameter1['E̗]'];
    BarImage1.BarSpaceRight := UpDown5.Position;
    ComboBox6.ItemIndex := Parameter1['Rs[@'];
    j := ComboBox6.ItemIndex;
    if j > 0 then
      Dec(j);
    BarImage1.BarPicture := TPictures(j);
    UpDown3.Position := Parameter1['Gg'];
    BarImage1.ElementRatio := TElementRatio(UpDown3.Position);
    UpDown7.Position := Parameter1['̌'];
    UpDown8.Position := Parameter1['̔{'];
    BarImage1.BarColor := TColor(Parameter1['o[R[h̐F']);
    BarImage1.BackColor := TColor(Parameter1['o[R[h̔wiF']);
    OrgHeight := Parameter1['OrgHeight'];
    slist := Parameter1.VBools['{̏Ԃ\킷XCb`'];
    gapheight := Parameter1['̍sԊu'];
    Panel7.Caption := 's = ' + IntToStr(gapheight);
    gapwidth := Parameter1['̗Ԋu'];
    Panel8.Caption := ' = ' + IntToStr(gapwidth);
    startx := Parameter1['Jn_XW'];
    Panel9.Caption := 'X = ' + IntToStr(startx);
    starty := Parameter1['Jn_YW'];
    Panel10.Caption := 'Y = ' + IntToStr(starty);
    i := Parameter1['\[g'];
    case i of
      0: SortBox := ComboBox1;
      1: SortBox := ComboBox7;
      2: SortBox := ComboBox8;
    end;
    i := Parameter1['\[g'];
    case i of
      0: SortOrder := 1;
      1: SortOrder := -1;
    end;
    FontDialog1.Font.Name := Parameter1.VStrings['FontName'];
    FontDialog1.Font.Size := Parameter1['FontSize'];
    FontDialog1.Font.Style := Parameter1.VFontStyles['FontStyle'];
    FontDialog1.Font.Color := TColor(Parameter1['FontColor']);
    BarImage1.BarFont := FontDialog1.Font;
    SaveDir := Parameter1.VStrings['SaveDir'];

    ComboBox2Change(Sender);
  end
  else
  begin
    ComboBox2.ItemIndex := 0;
    ComboBox3.ItemIndex := 0;
    ComboBox3.Text := ' ';
    ComboBox4.ItemIndex := 0;
    ComboBox4.Text := ' ';
    ComboBox5.ItemIndex := 0;
    ComboBox6.ItemIndex := 0;
    OrgHeight := BarImage1.BarHeight;
    slist := False;
    gapwidth := 0;
    Panel7.Caption := ' = ' + IntToStr(gapwidth);
    gapheight := 10;
    Panel8.Caption := 's = ' + IntToStr(gapheight);
    startx := 0;
    Panel9.Caption := 'X = ' + IntToStr(startx);
    starty := 0;
    Panel10.Caption := 'Y = ' + IntToStr(starty);
    SortBox := ComboBox1;
    SortOrder := 1;
    SaveDir := '';

    DispFrom(Integer(BarImage1.BarType));
  end;

  if err2 = False then  // o[R[h̐ݒ
  begin
    if err1 = False then
    begin
      p := Parameter1['o[R[h'];
      if (p < 0) or (p >= ComboBox1.Items.Count) then
        ComboBox1.ItemIndex := 0
      else
        ComboBox1.ItemIndex := p;
    end
    else
      ComboBox1.ItemIndex := 0;

    godisp := True;
  end
  else
  begin
    if err1 = False then
      Panel5.Caption := '';
  end;

  err1 := False;
  err2 := False;
  p := ComboBox1.ItemIndex;
  len := ComboBox1.Items.Count;

  try
    ComboBox7.Items.LoadFromFile(FileName + 'BarKunUp.txt');
  except
    err1 := True;
  end;

  if (err1 = False) and (ComboBox7.Items.Count <> len) then
    err1 := True;

  if err1 = True then
  begin
    ComboBox7.Items.Clear;
    for i := 1 to len do
      ComboBox7.Items.Add('');
  end;

  ComboBox7.ItemIndex := p;

  try
    ComboBox8.Items.LoadFromFile(FileName + 'BarKunDn.txt');
  except
    err2 := True;
  end;

  if (err2 = False) and (ComboBox8.Items.Count <> len) then
    err2 := True;

  if err2 = True then
  begin
    ComboBox8.Items.Clear;
    for i := 1 to len do
      ComboBox8.Items.Add('');
  end;

  ComboBox8.ItemIndex := p;

  if godisp = True then
  begin
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.Code := ComboBox1.Text;
    BarImage1.BarEnabled := True;
    DispCheck;
  end
  else
    BarImage1.BarEnabled := True;

  plist := False;
  OldIndex := ComboBox1.ItemIndex;
end;

procedure TFrameForm.Button4Click(Sender: TObject);
var
  Jpeg: TJPEGImage;
begin
  if BarImage1.BarDisped = False then
    Exit;

  SaveDialog1.FilterIndex := ComboBox6.ItemIndex + 1;
  SaveDialog1.InitialDir := SaveDir;

  case ComboBox6.ItemIndex of
    0:
    begin
      SaveDialog1.FileName := 'BarKun.bmp';
      SaveDialog1.DefaultExt := 'bmp';
    end;
    1:
    begin
      SaveDialog1.FileName := 'BarKun.jpg';
      SaveDialog1.DefaultExt := 'jpg';
    end;
    2:
    begin
      SaveDialog1.FileName := 'BarKun.emf';
      SaveDialog1.DefaultExt := 'emf';
    end;
    3:
    begin
      SaveDialog1.FileName := 'BarKun.wmf';
      SaveDialog1.DefaultExt := 'wmf';
    end;
  end;

  if SaveDialog1.Execute = True then
  begin
    case ComboBox6.ItemIndex of
      0:
        BarImage1.Picture.Bitmap.SaveToFile(SaveDialog1.FileName);
      1:
      begin
        Jpeg := TJPEGImage.Create;
        try
          Jpeg.Assign(BarImage1.Picture.Bitmap);
          Jpeg.SaveToFile(SaveDialog1.Filename);
        finally
          Jpeg.Free;
        end;
      end;
      2:
      begin
        BarImage1.Picture.Metafile.Enhanced := True;
        BarImage1.Picture.Metafile.SaveToFile(SaveDialog1.FileName);
      end;
      3:
      begin
        BarImage1.Picture.Metafile.Enhanced := False;
        BarImage1.Picture.Metafile.SaveToFile(SaveDialog1.FileName);
      end;
    end;
    SaveDir := ExtractFileDir(SaveDialog1.FileName);
  end;
end;

procedure TFrameForm.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i, j: Integer;
begin
  if (Key = $0D) and (ComboBox1.Text <> '') then
  begin
    j := -1;
    for i := 0 to ComboBox1.Items.Count - 1 do
    begin
      if ComboBox1.Items.Strings[i] = ComboBox1.Text then
      begin
        j := i;
        Break;
      end;
    end;

    if j = -1 then
    begin
      if ComboBox1.Items.Count = 0 then
      begin
        ComboBox1.Items.Add(ComboBox1.Text);
        ComboBox1.ItemIndex := 0;
        ComboBox7.Items.Add(ComboBox7.Text);
        ComboBox7.ItemIndex := 0;
        ComboBox8.Items.Add(ComboBox8.Text);
        ComboBox8.ItemIndex := 0;
      end
      else
      begin
        ComboBox1.Items.Insert(OldIndex + 1, ComboBox1.Text);
        ComboBox1.ItemIndex := OldIndex + 1;
        ComboBox7.Items.Insert(OldIndex + 1, ComboBox7.Text);
        ComboBox7.ItemIndex := OldIndex + 1;
        ComboBox8.Items.Insert(OldIndex + 1, ComboBox8.Text);
        ComboBox8.ItemIndex := OldIndex + 1;
      end;
    end
    else
    begin
      ComboBox1.ItemIndex := j;
      ComboBox7.ItemIndex := j;
      ComboBox8.ItemIndex := j;
    end;

    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.Code := ComboBox1.Text;
    BarImage1.BarEnabled := True;

    OldIndex := ComboBox1.ItemIndex;
    DispCheck;
  end;
end;

procedure TFrameForm.ComboBox1Change(Sender: TObject);
begin
  { ҏW{bNXɉ͂ }
  { Vf[^̓͂n߂ƂȂ̂ }
  if ComboBox1.ItemIndex = -1 then
  begin
    ComboBox7.ItemIndex := -1; // ComboBox7 ̕ҏW{bNXNA[B
    ComboBox8.ItemIndex := -1; // ComboBox8 ̕ҏW{bNXNA[B
    Exit;
  end;

  { hbv_EXg̃f[^I }
  if ComboBox1.ItemIndex <> OldIndex then
  begin
    ComboBox7.ItemIndex := ComboBox1.ItemIndex;
    ComboBox8.ItemIndex := ComboBox1.ItemIndex;
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.Code := ComboBox1.Text;
    BarImage1.BarEnabled := True;
    OldIndex := ComboBox1.ItemIndex;
    DispCheck;
  end;
end;

procedure TFrameForm.ComboBox2Change(Sender: TObject);
var
  i, j: Integer;
begin
  BarImage1.Enabled := False;       // o[R[h\ꎞIɋ֎~B
  i := Integer(BarImage1.BarType);  // BarType
  j := ComboBox2.ItemIndex;         // VBarType
  BarImage1.BarType := TBarTypes(j);

  if j = 9 then                     // cbarCUSTOMEȐꍇ
  begin
    Edit2.Enabled := False;
    UpDown2.Enabled := False;
  end
  else if (i = 9) and (j <> i) then // cbarCUSTOMERȊȌꍇ
  begin
    Edit2.Enabled := True;
    UpDown2.Enabled := True;
    BarImage1.BarHeight := OrgHeight;
  end;

  if (j < 2) or (j = 6) or (j > 8) then
  begin
    CheckBox1.Checked := True;      // cbarJAN, cbarUPC, cbarIATA, cbarCUSTOMER,
    CheckBox1.Enabled := False;     // cbarCODE128, cbarCODE93 ̏ꍇ
  end
  else                              // LȊȌꍇ
  begin
    CheckBox1.Checked := BarImage1.CD;
    CheckBox1.Enabled := True;
  end;

  if (j < 2) or (j > 8) then        // cbarJAN, cbarUPC, cbarCUSTOMER,
  begin                             // cbarCODE128, cbarcode93 ̏ꍇ
    Edit3.Enabled := False;
    UpDown3.Enabled := False;
  end
  else                              // LȊȌꍇ
  begin
    Edit3.Enabled := True;
    UpDown3.Enabled := True;
  end;

  if j = 2 then                     // cbarCODE39̏ꍇ
  begin
    ComboBox3.Style := csDropDown;
    ComboBox3.Text := '*';          // X^[gLN^́A'*'ŌŒ
    ComboBox3.Enabled := False;
  end
  else if j = 11 then               // cbarCODE93̏ꍇ
  begin
    ComboBox3.Style := csDropDown;
    ComboBox3.Text := '(';          // X^[gLN^́A'('ŌŒ
    ComboBox3.Enabled := False;
  end
  else if (j < 2) or ((j >= 4) and (j <= 9)) then
  begin                             // cbarJAN, cbarUPC, cbarITF, cbarCTF, cbarIATA,
    ComboBox3.Style := csDropDown;  // cbarMATRIX, cbarNEC, cbarCUSTOMEȐꍇ
    ComboBox3.Text := ' ';          // X^[gLN^gpȂB
    ComboBox3.Enabled := False;
  end
  else                              // cbarNW7, cbarCODE128̏ꍇ
  begin
    ComboBox3.Style := csDropDownList;
    if (j = 5) and (BarImage1.StartChar > 'C') then // cbarCODE128̏ꍇ
      BarImage1.StartChar := 'A';

    ComboBox3.ItemIndex := Integer(BarImage1.StartChar) - Integer('A');
    ComboBox3.Enabled := True;
  end;

  if j = 2 then                     // cbarCODE39̏ꍇ
  begin
    ComboBox4.Style := csDropDown;
    ComboBox4.Text := '*';          // XgbvLN^́A'*'ŌŒ
    ComboBox4.Enabled := False;
  end
  else if j = 11 then               // cbarCODE93̏ꍇ
  begin
    ComboBox4.Style := csDropDown;
    ComboBox4.Text := ')';          // XgbvLN^́A')'ŌŒ
    ComboBox4.Enabled := False;
  end
  else if (j < 2) or (j > 3) then   // cbarJAN, cbarUPC, cbarITF, cbarCTF, cbarIATA,
  begin
    ComboBox4.Style := csDropDown;  // cbarMATRIX, cbarNEC, cbarCUSTOMER, cbarCODE128
    ComboBox4.Text := ' ';          // ̏ꍇXgbvLN^gpȂB
    ComboBox4.Enabled := False;
  end
  else                              // cbarNW7̏ꍇ
  begin
    ComboBox4.Style := csDropDownList;
    ComboBox4.ItemIndex := Integer(BarImage1.StopChar) - Integer('A');
    ComboBox4.Enabled := True;
  end;

  if j = 1 then                     // cbarUPC̏ꍇ
    Button7.Enabled := True
  else                              // LȊȌꍇ
    Button7.Enabled := False;

  BarImage1.Enabled := True;        // o[R[h\B

  DispCheck;
  DispFrom(Integer(BarImage1.BarType));
end;

procedure TFrameForm.FormResize(Sender: TObject);
begin
  Panel2.Top := ClientHeight - Panel3.Height - Panel2.Height;
  Panel6.Top := Panel2.Top;
  Panel6.Width := ClientWidth - Panel2.Width;
  ScrollBox1.Height := Panel2.Top;
  DispFrom(Integer(BarImage1.BarType));
end;

procedure TFrameForm.Edit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    BarImage1.BarHeight := UpDown2.Position;
    OrgHeight := BarImage1.BarHeight;
    DispCheck;
  end;
end;

procedure TFrameForm.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.BarHeight := UpDown2.Position;
  OrgHeight := BarImage1.BarHeight;
  DispCheck;
end;

procedure TFrameForm.Edit3KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    BarImage1.ElementRatio := UpDown3.Position;
    DispCheck;
  end;
end;

procedure TFrameForm.UpDown3Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.ElementRatio := UpDown3.Position;
  DispCheck;
end;

procedure TFrameForm.CheckBox1Click(Sender: TObject);
begin
  BarImage1.CD := CheckBox1.Checked;
  DispCheck;
end;

procedure TFrameForm.ComboBox3Change(Sender: TObject);
begin
  if (BarImage1.BarType = cbarCODE128) and (ComboBox3.ItemIndex > 2) then
    ComboBox3.ItemIndex := 0;

  BarImage1.StartChar := Char(Integer('A') + ComboBox3.ItemIndex);
  DispCheck;
end;

procedure TFrameForm.ComboBox4Change(Sender: TObject);
begin
  BarImage1.StopChar := Char(Integer('A') + ComboBox4.ItemIndex);
  DispCheck;
end;

procedure TFrameForm.ComboBox5Change(Sender: TObject);
var
  p: Integer;
  i: Integer;
begin
  p := ComboBox5.ItemIndex;
  i := p;
  if i = 1 then
    i := 2;
  BarImage1.BarPicture := TPictures(p);
  ComboBox6.ItemIndex := i;
  DispCheck;
end;

procedure TFrameForm.ComboBox6Change(Sender: TObject);
var
  i: Integer;
  p: Integer;
begin
  i := ComboBox6.ItemIndex;
  p := i;
  i := i div 2;
  if p > 0 then
    Dec(p);
  ComboBox5.ItemIndex := i;
  BarImage1.BarPicture := TPictures(p);
  DispCheck;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  ColorDialog1.Color := BarImage1.BarColor;
  if ColorDialog1.Execute = True then
  begin
    BarImage1.BarColor := ColorDialog1.Color;
    DispCheck;
  end;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  ColorDialog1.Color := BarImage1.BackColor;
  if ColorDialog1.Execute = True then
  begin
    BarImage1.BackColor := ColorDialog1.Color;
    DispCheck;
  end;
end;

procedure TFrameForm.Button3Click(Sender: TObject);
var
  Jpeg: TJPEGImage;
  MemStream: TMemoryStream;
begin
  if BarImage1.BarDisped = True then
  begin
    if ComboBox6.ItemIndex = 1 then // JPEG `ŃRs[
    begin
      Jpeg := TJPEGImage.Create;
      try
        Jpeg.Assign(BarImage1.Picture.Graphic);
        MemStream := TMemoryStream.Create;
        try
          Jpeg.SaveToStream(MemStream);
          Stream2Clipboard(CF_JFIF, MemStream);
        finally
          MemStream.Free;
        end;
      finally
        Jpeg.Free;
      end;
    end
    else
      BarImage1.CopyToClipboard;
  end;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  i: Integer;
  FileName: String;
  DList: TStringList;
begin
  FileName := Application.ExeName;
  FileName := ExtractFilePath(FileName);

  ComboBox1.Items.SaveToFile(FileName + 'BarKun.txt');
  ComboBox7.Items.SaveToFile(FileName + 'BarKunUp.txt');
  ComboBox8.Items.SaveToFile(FileName + 'BarKunDn.txt');

  DList := TStringList.Create;
  DList.Clear;
  if Parameter1.Count = 0 then
  begin
    DList.Add('DLeft=191');
    DList.Add('DTop=182');
    DList.Add('DWidth=598');
    DList.Add('DHeight=378');
    DList.Add('DWindowState=0');
    DList.Add('DFontName=lr oSVbN');
    DList.Add('DFontSize=9');
    DList.Add('DFontStyle=[]');
    DList.Add('DFontColor=-2147483640');
    DList.Add('DDefaultRowHeight=24');
    DList.Add('DColWidths[1]=180');
    DList.Add('DColWidths[2]=176');
    DList.Add('DColWidths[3]=162');
    DList.Add('DPartition=1');
    DList.Add('G^[L[Ŏ̍sɈړ=False');
    DList.Add('펞͂̏=False');
    DList.Add('G^[L[Ńf[^`FbN=False');
    DList.Add('SɈv镶=False');
    DList.Add('=' + #26);
  end
  else if Pos('DLeft=', Parameter1.Params[0]) <> 0 then
  begin
    for i := 0 to Parameter1.Count - 1 do
    begin
      DList.Add(Parameter1.Params[0]);
      Parameter1.Delete(0);
    end;
  end;

  if Parameter1.Count = 0 then
  begin
    Parameter1.Add('o[R[hNݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['Left'] := Left;
    Parameter1['Top'] := Top;
    Parameter1['Width'] := Width;
    Parameter1['Height'] := Height;
  end
  else
  begin
    if WindowState <> wsMaximized then
    begin
      Parameter1['Left'] := Left;
      Parameter1['Top'] := Top;
      Parameter1['Width'] := Width;
      Parameter1['Height'] := Height;
    end;
  end;
  Parameter1['WindowState'] := Integer(WindowState);
  Parameter1['o[R[h'] := ComboBox1.ItemIndex;
  Parameter1['o[R[h̎'] := ComboBox2.ItemIndex;
  Parameter1['X^[gLN^'] := ComboBox3.ItemIndex;
  Parameter1['XgbvLN^'] := ComboBox4.ItemIndex;
  Parameter1.VBools['\'] := CheckBox2.Checked;
  Parameter1.VBools['`FbNfWbg'] := CheckBox1.Checked;
  Parameter1.VBools['Nbv{[hĎ'] := CheckBox3.Checked;
  Parameter1['XP['] := UpDown1.Position;
  Parameter1['ITFt['] := UpDown6.Position;
  Parameter1['\`'] := ComboBox5.ItemIndex;
  Parameter1[''] := UpDown2.Position;
  Parameter1['̗]'] := UpDown9.Position;
  Parameter1['̗]'] := UpDown10.Position;
  Parameter1['̗]'] := UpDown4.Position;
  Parameter1['E̗]'] := UpDown5.Position;
  Parameter1['Rs[@'] := ComboBox6.ItemIndex;
  Parameter1['Gg'] := UpDown3.Position;
  Parameter1['̌'] := UpDown7.Position;
  Parameter1['̔{'] := UpDown8.Position;
  Parameter1['o[R[h̐F'] := Integer(BarImage1.BarColor);
  Parameter1['o[R[h̔wiF'] := Integer(BarImage1.BackColor);
  Parameter1['OrgHeight'] := OrgHeight;
  Parameter1.VBools['{̏Ԃ\킷XCb`'] := slist;
  Parameter1['̍sԊu'] := gapheight;
  Parameter1['̗Ԋu'] := gapwidth;
  Parameter1['Jn_XW'] := startx;
  Parameter1['Jn_YW'] := starty;

  if SortBox = ComboBox1 then i := 0
  else if SortBox = ComboBox7 then i := 1
  else if SortBox = ComboBox8 then i := 2
  else i := 0;
  Parameter1['\[g'] := i;

  if SortOrder = 1 then i := 0
  else if SortOrder = -1 then i := 1
  else i := 0;
  Parameter1['\[g'] := i;

  Parameter1.VStrings['FontName'] := FontDialog1.Font.Name;
  Parameter1['FontSize'] := FontDialog1.Font.Size;
  Parameter1.VFontStyles['FontStyle'] := FontDialog1.Font.Style;
  Parameter1['FontColor'] := Integer(FontDialog1.Font.Color);
  Parameter1.VStrings['SaveDir'] := SaveDir;

  if DList.Count <> 0 then
  begin
    for i := 0 to DList.Count - 1 do
      Parameter1.Add(DList.Strings[i]);
  end;
  DList.Free;

  Parameter1.SaveToFile;
end;

procedure TFrameForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    BarImage1.Scale := UpDown1.Position;

  DispCheck;
end;

procedure TFrameForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.Scale := UpDown1.Position;

  DispCheck;
end;

procedure TFrameForm.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked = True then
    BarImage1.SymbolDisp := True
  else
    BarImage1.SymbolDisp := False;

  if BarImage1.BarType <> cbarCUSTOMER then
    OrgHeight := BarImage1.BarHeight;

  DispCheck;
end;

procedure TFrameForm.DispFrom(bartype: Integer);
var
  row: array [0..11] of Integer;
begin
  row[0] := 68;  row[1] := 88;  row[2] := 108;   row[3] := 173;
  row[4] := 193; row[5] := 213; row[6] := 233;  row[7] := 253;
  row[8] := 273; row[9] := 293; row[10] := 313; row[11] := 457;

  Memo1.SelStart := SendMessage(Memo1.Handle, EM_LINEINDEX, Memo1.Lines.Count - 1, 0);
  Memo1.Perform(EM_SCROLLCARET, 0, 0);

  Memo1.SelStart := SendMessage(Memo1.Handle, EM_LINEINDEX, row[bartype], 0);
  Memo1.Perform(EM_SCROLLCARET, 0, 0);
end;

procedure TFrameForm.Edit5KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    BarImage1.BarSpaceRight := UpDown5.Position;
    DispCheck;
  end;
end;

procedure TFrameForm.UpDown5Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.BarSpaceRight := UpDown5.Position;
  DispCheck;
end;

procedure TFrameForm.Edit4KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    BarImage1.BarSpaceLeft := UpDown4.Position;
    DispCheck;
  end;
end;

procedure TFrameForm.UpDown4Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.BarSpaceLeft := UpDown4.Position;
  DispCheck;
end;

procedure TFrameForm.Button6Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Button5Click(Sender: TObject);
var
  i: Integer;
begin
  i := ComboBox1.ItemIndex;
  if i = -1 then
    Exit;

  ComboBox1.Items.Delete(i);
  ComboBox7.Items.Delete(i);
  ComboBox8.Items.Delete(i);
  if ComboBox1.Items.Count <> 0 then
  begin
    if i = ComboBox1.Items.Count then
      Dec(i);
    ComboBox1.ItemIndex := i;
    ComboBox7.ItemIndex := i;
    ComboBox8.ItemIndex := i;
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.Code := ComboBox1.Text;
    BarImage1.BarEnabled := True;
  end
  else
  begin
    ComboBox1.Text := '';
    ComboBox1.ItemIndex := -1;
    ComboBox7.Text := '';
    ComboBox7.ItemIndex := -1;
    ComboBox8.Text := '';
    ComboBox8.ItemIndex := -1;
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := '';
    BarImage1.CommentDown := '';
    BarImage1.Code := '';
    BarImage1.BarEnabled := True;
    Panel5.Caption := '';
  end;
  DispCheck;
  OldIndex := ComboBox1.ItemIndex;
end;

procedure TFrameForm.DispCheck;
begin
  if UpDown2.Position <> BarImage1.BarHeight then
  begin
    UpDown2.Position := BarImage1.BarHeight;
    Edit2.Text := IntToStr(BarImage1.BarHeight);
  end;

  if UpDown6.Position <> BarImage1.BarFrame then
  begin
    UpDown6.Position := BarImage1.BarFrame;
    Edit6.Text := IntToStr(BarImage1.BarFrame);
  end;
  
  if BarImage1.BarDisped = True then
  begin
    Panel4.Caption := IntToStr(BarImage1.BarWidth);
    Panel5.Font.Color := clBlue;
    Panel5.Caption := '\܂B';
  end
  else
  begin
    Panel4.Caption := '0';
    Panel5.Font.Color := clRed;
    Panel5.Caption := '\o܂B';
  end;
  Label1.Caption := 'o[R[h (' + IntToStr(ComboBox1.ItemIndex + 1) +
                                 ' of ' + IntToStr(ComboBox1.Items.Count) + ')';

  if BarImage1.CDN = -1 then
  begin
    Panel1.Caption := '';
    Panel1.Hint := '`FbNfWbg';
  end
  else
  begin
    if BarImage1.BarType = cbarCODE93 then
      Panel1.Caption := BarImage1.CDC + ' ('
       + IntToStr(BarImage1.CDN mod 100) + ', ' + IntToStr(BarImage1.CDN div 100) + ')'
    else
      Panel1.Caption := BarImage1.CDC + ' (' + IntToStr(BarImage1.CDN) + ')';
    Panel1.Hint := '`FbNfWbg(JbR͐lx[X)';
  end;
end;

procedure TFrameForm.Button7Click(Sender: TObject);
var
  i, j: Integer;
begin
  if BarImage1.BarType = cbarUPC then
  begin
    if Length(BarImage1.Code) = 11 then
      BarImage1.RepaintUPCA2E
    else if Length(BarImage1.Code) = 7 then
      BarImage1.RepaintUPCE2A;

    if BarImage1.BarDisped = True then
    begin
      Panel5.Font.Color := clBlue;
      Panel5.Caption := 'ϊ܂B';

      ComboBox1.Text := BarImage1.Code;

      j := -1;
      for i := 0 to ComboBox1.Items.Count - 1 do
      begin
        if ComboBox1.Items.Strings[i] = BarImage1.Code then
        begin
          j := i;
          break;
        end;
      end;

      if j = -1 then
      begin
        ComboBox1.Items.Insert(OldIndex + 1, ComboBox1.Text);
        ComboBox1.ItemIndex := OldIndex + 1;
        ComboBox7.Items.Insert(OldIndex + 1, '');
        ComboBox7.ItemIndex := OldIndex + 1;
        ComboBox8.Items.Insert(OldIndex + 1, '');
        ComboBox8.ItemIndex := OldIndex + 1;
      end
      else
      begin
        ComboBox1.ItemIndex := j;
        ComboBox7.ItemIndex := j;
        ComboBox8.ItemIndex := j;
      end;

      OldIndex := ComboBox1.ItemIndex;
    end
    else
    begin
      Panel5.Font.Color := clRed;
      Panel5.Caption := 'ϊo܂B';
    end;
  end;
end;

procedure TFrameForm.Edit6KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    BarImage1.BarFrame := UpDown6.Position;
    if BarImage1.BarType <> cbarCUSTOMER then
      OrgHeight := BarImage1.BarHeight;
    DispCheck;
  end;
end;

procedure TFrameForm.UpDown6Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.BarFrame := UpDown6.Position;
  if BarImage1.BarType <> cbarCUSTOMER then
    OrgHeight := BarImage1.BarHeight;
  DispCheck;
end;

procedure TFrameForm.Button9Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
  slist := False;
end;

procedure TFrameForm.Button8Click(Sender: TObject);
var
  i, j, n, count: Integer;
  re: Integer;
  gapw, gaph: Integer;
  row, column: Integer;
  w, h: Integer;
  r: Integer;        // ̔{(%P)
  p, len: Integer;
  TempFile: String;
  Ext: String;
  graphic: TGraphic;
  bitmap: TBitmap;
  metafile: TMetafile;
begin
  bitmap := nil;
  metafile := nil;

  if (BarImage1.BarDisped = False) or (ComboBox1.Items.Count = 0) then
  begin
    ShowMessage('o[R[h\łȂƈo܂B');
    Exit;
  end;

  PreviewForm := TPreviewForm.Create(Self);

  re := PreviewForm.ShowModal;

  PreviewForm.Free;

  if re <> mrOk then
    Exit;

  r := UpDown8.Position;

  TempFile := Application.ExeName;
  Ext := ExtractFileName(TempFile);
  p := Pos(Ext, TempFile);
  len := Length(Ext);
  Delete(TempFile, p, len);

  gapw := ((gapwidth * pxi * r) div sxi) div 100;
  gaph := ((gapheight * pyi * r) div syi) div 100;
  w := ((BarImage1.Width * pxi * r) div sxi) div 100;
  h := ((BarImage1.Height * pyi * r) div syi) div 100;

  column := 0;
  n := pwidth;
  while n > 0 do
  begin
    if n >= w then
      Inc(column);
    Dec(n, w + gapw);
  end;
  if column = 0 then
    column := 1;

  row := 0;
  n := pheight;
  while n > 0 do
  begin
    if n >= h then
      Inc(row);
    Dec(n, h + gaph);
  end;
  if row = 0 then
    row := 1;

  n := UpDown7.Position;
  count := 0;

  if BarImage1.BarPicture = picBMP then
  begin
    TempFile := TempFile + 'Temp0000.bmp';
    BarImage1.Picture.Bitmap.SaveToFile(TempFile);

    bitmap := TBitmap.Create;

    bitmap.LoadFromFile(TempFile);
    graphic := bitmap;
  end
  else
  begin
    TempFile := TempFile + 'Temp0000.emf';
    BarImage1.Picture.Metafile.Enhanced := True;
    BarImage1.Picture.Metafile.SaveToFile(TempFile);

    metafile := TMetafile.Create;

    metafile.LoadFromFile(TempFile);
    graphic := metafile;
  end;

  DeleteFile(TempFile);

  Printer.BeginDoc;
  while count < n do
  begin
    for j := 0 to row - 1 do
    begin
      for i := 0 to column - 1 do
      begin
        Printer.Canvas.StretchDraw(Rect(i * (w + gapw),
                                        j * (h + gaph),
                                        i * (w + gapw) + w,
                                        j * (h + gaph) + h), graphic);
        Inc(count);
        if count = n then
          Break;
      end;
      if count = n then
        Break;
    end;
    if count = n then
      Break;
    Printer.NewPage;
  end;
  Printer.EndDoc;

  if BarImage1.BarPicture = picBMP then
    bitmap.Free
  else
    metafile.Free;
end;

procedure TFrameForm.Button10Click(Sender: TObject);
var
  x, y, n, count: Integer;
  hmax: Integer;
  re: Integer;
  gapw, gaph: Integer;
  w, h: Integer;
  r: Integer;                  // ̔{(%P)
  p, len: Integer;
  TempFile: String;
  Ext: String;
  Bcode: String;
  Up: String;
  Down: String;
  graphic: TGraphic;
  bitmap: TBitmap;
  metafile: TMetafile;
begin
  bitmap := nil;
  metafile := nil;
  Bcode := BarImage1.Code;
  Up := BarImage1.CommentUp;
  Down := BarImage1.CommentDown;
  plist := True;               // XgłƂtO

  BarImage1.BarDebug := True;  // fobO[h
  nlist := 0;
  for n := 0 to ComboBox1.Items.Count - 1 do
  begin
    BarImage1.Code := ComboBox1.Items.Strings[n];
    if BarImage1.BarDisped = True then
      Inc(nlist);
  end;
  BarImage1.BarDebug := False;

  if (ComboBox1.Items.Count = 0) or (nlist = 0) then
  begin
    ShowMessage('Xgɕ\\ȃf[^Ȃ׈o܂B');
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := Up;
    BarImage1.CommentDown := Down;
    BarImage1.Code := Bcode;
    BarImage1.BarEnabled := True;
    plist := False;
    Exit;
  end;

  PreviewForm := TPreviewForm.Create(Self);

  re := PreviewForm.ShowModal;

  PreviewForm.Free;

  if re <> mrOk then
  begin
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := Up;
    BarImage1.CommentDown := Down;
    BarImage1.Code := Bcode;
    BarImage1.BarEnabled := True;
    plist := False;
    Exit;
  end;

  r := UpDown8.Position;

  TempFile := Application.ExeName;
  Ext := ExtractFileName(TempFile);
  p := Pos(Ext, TempFile);
  len := Length(Ext);
  Delete(TempFile, p, len);

  gapw := ((gapwidth * pxi * r) div sxi) div 100;
  gaph := ((gapheight * pyi * r) div syi) div 100;

  n := ComboBox1.Items.Count;
  count := 0;

  if BarImage1.BarPicture = picBMP then
  begin
    TempFile := TempFile + 'Temp0000.bmp';
    bitmap := TBitmap.Create;
  end
  else
  begin
    TempFile := TempFile + 'Temp0000.emf';
    metafile := TMetafile.Create;
  end;

  Printer.BeginDoc;
  while count < n do
  begin
    y := 0;
    while y < pheight do
    begin
      x := 0;
      hmax := 0;
      while x < pwidth do
      begin
        BarImage1.BarEnabled := False;
        BarImage1.CommentUp := ComboBox7.Items.Strings[count];
        BarImage1.CommentDown := ComboBox8.Items.Strings[count];
        BarImage1.Code := ComboBox1.Items.Strings[count];
        BarImage1.BarEnabled := True;
        if BarImage1.BarDisped = True then
        begin
          if BarImage1.BarPicture = picBMP then
          begin
            BarImage1.Picture.Bitmap.SaveToFile(TempFile);
            bitmap.LoadFromFile(TempFile);
            graphic := bitmap;
          end
          else
          begin
            BarImage1.Picture.Metafile.Enhanced := True;
            BarImage1.Picture.Metafile.SaveToFile(TempFile);
            metafile.LoadFromFile(TempFile);
            graphic := metafile;
          end;
          w := ((BarImage1.Width * pxi * r) div sxi) div 100;
          h := ((BarImage1.Height * pyi * r) div syi) div 100;
          if (x > 0) and (x + w > pwidth) then
            Break;
          if (y > 0) and (y + h > pheight) then
          begin
            hmax := h;
            Break;
          end;
          Printer.Canvas.StretchDraw(Rect(x,
                                          y,
                                          x + w,
                                          y + h), graphic);
          x := x + w + gapw;
          if h > hmax then
            hmax := h;
        end;
        Inc(count);
        if count = n then
          Break;
      end;
      y := y + hmax + gaph;
      if count = n then
        Break;
    end;
    if count = n then
      Break;
    Printer.NewPage;
  end;
  Printer.EndDoc;

  DeleteFile(TempFile);

  if BarImage1.BarPicture = picBMP then
    bitmap.Free
  else
    metafile.Free;

  BarImage1.BarEnabled := False;
  BarImage1.CommentUp := Up;
  BarImage1.CommentDown := Down;
  BarImage1.Code := Bcode;
  BarImage1.BarEnabled := True;
  plist := False;
end;

procedure TFrameForm.Button11Click(Sender: TObject);
begin
  FontDialog1.Font := BarImage1.BarFont;
  if FontDialog1.Execute = True then
  begin
    BarImage1.BarFont := FontDialog1.Font;
    DispCheck;
  end;
end;

procedure TFrameForm.ComboBox7Change(Sender: TObject);
begin
  if (ComboBox7.ItemIndex <> -1) and (ComboBox7.ItemIndex <> OldIndex) then
  begin
    ComboBox1.ItemIndex := ComboBox7.ItemIndex;
    ComboBox8.ItemIndex := ComboBox7.ItemIndex;
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.Code := ComboBox1.Text;
    BarImage1.BarEnabled := True;
    OldIndex := ComboBox1.ItemIndex;
    DispCheck;
  end;
end;

procedure TFrameForm.ComboBox7KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: Integer;
begin
  if Key <> $0D then
    Exit;

  { Vf[^̃Rg͂ꍇ }
  if ComboBox1.ItemIndex = -1 then
  begin
    ComboBox1KeyDown(Sender, Key, Shift);
    Exit;
  end;

  { ̃f[^̃Rg͂ꍇ }
  if ComboBox1.Items.Count > 0 then
  begin
    i := ComboBox1.ItemIndex;
    ComboBox7.Items.Strings[i] := ComboBox7.Text;
    ComboBox7.ItemIndex := i;
    ComboBox8.Items.Strings[i] := ComboBox8.Text;
    ComboBox8.ItemIndex := i;

    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.BarEnabled := True;

    OldIndex := i;
    DispCheck;
  end;
end;

procedure TFrameForm.ComboBox8Change(Sender: TObject);
begin
  if (ComboBox8.ItemIndex <> -1) and (ComboBox8.ItemIndex <> OldIndex) then
  begin
    ComboBox1.ItemIndex := ComboBox8.ItemIndex;
    ComboBox7.ItemIndex := ComboBox8.ItemIndex;
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.Code := ComboBox1.Text;
    BarImage1.BarEnabled := True;
    OldIndex := ComboBox1.ItemIndex;
    DispCheck;
  end;
end;

procedure TFrameForm.ComboBox8KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: Integer;
begin
  if Key <> $0D then
    Exit;

  { Vf[^̃Rg͂ꍇ }
  if ComboBox1.ItemIndex = -1 then
  begin
    ComboBox1KeyDown(Sender, Key, Shift);
    Exit;
  end;

  { ̃f[^̃Rg͂ꍇ }
  if ComboBox1.Items.Count > 0 then
  begin
    i := ComboBox1.ItemIndex;
    ComboBox8.Items.Strings[i] := ComboBox8.Text;
    ComboBox8.ItemIndex := i;
    ComboBox7.Items.Strings[i] := ComboBox7.Text;
    ComboBox7.ItemIndex := i;

    BarImage1.BarEnabled := False;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.BarEnabled := True;

    OldIndex := i;
    DispCheck;
  end;
end;

procedure TFrameForm.Button12Click(Sender: TObject);
var
  i, j: Integer;
begin
  BarImage1.BarEnabled := False;
  { RgăNbv{[h̃f[^y[XgB}
  BarImage1.CommentUp := '';
  BarImage1.CommentDown := '';
  BarImage1.Code := '';
  BarImage1.PasteFromClipboard;
  BarImage1.BarEnabled := True;

  if BarImage1.Code <> '' then
  begin
    j := -1;
    for i := 0 to ComboBox1.Items.Count - 1 do
    begin
      if ComboBox1.Items.Strings[i] = BarImage1.Code then
      begin
        j := i;
        Break;
      end;
    end;

    if j = -1 then
    begin
      if ComboBox1.Items.Count = 0 then
      begin
        ComboBox1.Items.Add(BarImage1.Code);
        ComboBox1.ItemIndex := 0;
        ComboBox7.Items.Add(BarImage1.CommentUp);
        ComboBox7.ItemIndex := 0;
        ComboBox8.Items.Add(BarImage1.CommentDown);
        ComboBox8.ItemIndex := 0;
      end
      else
      begin
        ComboBox1.Items.Insert(OldIndex + 1, BarImage1.Code);
        ComboBox1.ItemIndex := OldIndex + 1;
        ComboBox7.Items.Insert(OldIndex + 1, BarImage1.CommentUp);
        ComboBox7.ItemIndex := OldIndex + 1;
        ComboBox8.Items.Insert(OldIndex + 1, BarImage1.CommentDown);
        ComboBox8.ItemIndex := OldIndex + 1;
      end;
    end
    else
    begin
      ComboBox1.ItemIndex := j;
      ComboBox7.ItemIndex := j;
      ComboBox8.ItemIndex := j;

      BarImage1.BarEnabled := False;
      BarImage1.CommentUp := ComboBox7.Items.Strings[j];
      BarImage1.CommentDown := ComboBox8.Items.Strings[j];
      BarImage1.BarEnabled := True;
    end;
  end
  else
  begin
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Text;
    BarImage1.CommentDown := ComboBox8.Text;
    BarImage1.Code := ComboBox1.Text;
    BarImage1.BarEnabled := True;
  end;

  OldIndex := ComboBox1.ItemIndex;
  DispCheck;
end;

procedure TFrameForm.UpDown8Click(Sender: TObject; Button: TUDBtnType);
begin
  slist := False;
end;

procedure TFrameForm.UpDown9Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.BarSpaceUp := UpDown9.Position;
  DispCheck;
end;

procedure TFrameForm.UpDown10Click(Sender: TObject; Button: TUDBtnType);
begin
  BarImage1.BarSpaceDown := UpDown10.Position;
  DispCheck;
end;

procedure TFrameForm.Edit9KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    BarImage1.BarSpaceUp := UpDown9.Position;
    DispCheck;
  end;
end;

procedure TFrameForm.Edit10KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
  begin
    BarImage1.BarSpaceDown := UpDown10.Position;
    DispCheck;
  end;
end;

procedure TFrameForm.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked = True then
  begin
    Button12.Enabled := False;
    BarImage1.ClipWatch := True;
  end
  else
  begin
    BarImage1.ClipWatch := False;
    Button12.Enabled := True;
  end;
end;

procedure TFrameForm.Panel7MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  g: Integer;
begin
  g := 0;
  if ssLeft in Shift then       // }EX̍{^ꂽB
  begin
    if ssShift in Shift then
      g := -10
    else if ssCtrl in Shift then
      g := -5
    else if ssAlt in Shift then
      g := -2
    else
      g := -1;
  end
  else if ssRight in Shift then // }EX̉E{^ꂽB
  begin
    if ssShift in Shift then
      g := 10
    else if ssCtrl in Shift then
      g := 5
    else if ssAlt in Shift then
      g := 2
    else
      g := 1;
  end;

  gapheight := gapheight + g;
  if gapheight < 0 then
    gapheight := 0
  else if gapheight > 2000 then
    gapheight := 2000;
  Panel7.Caption := 's = ' + IntToStr(gapheight);
end;

procedure TFrameForm.Panel8MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  g: Integer;
begin
  g := 0;
  if ssLeft in Shift then       // }EX̍{^ꂽB
  begin
    if ssShift in Shift then
      g := -10
    else if ssCtrl in Shift then
      g := -5
    else if ssAlt in Shift then
      g := -2
    else
      g := -1;
  end
  else if ssRight in Shift then // }EX̉E{^ꂽB
  begin
    if ssShift in Shift then
      g := 10
    else if ssCtrl in Shift then
      g := 5
    else if ssAlt in Shift then
      g := 2
    else
      g := 1;
  end;

  gapwidth := gapwidth + g;
  if gapwidth < 0 then
    gapwidth := 0
  else if gapwidth > 2000 then
    gapwidth := 2000;
  Panel8.Caption := ' = ' + IntToStr(gapwidth);
end;

procedure TFrameForm.UpDown11Click(Sender: TObject; Button: TUDBtnType);
var
  i: Integer;
begin
  if UpDown11.Tag = 1 then
  begin
    UpDown11.Tag := 0;
    Exit;
  end;
  
  i := ComboBox1.ItemIndex;
  if i = -1 then
    Exit;

  BarImage1.BarEnabled := False;
  if Button = btNext then
  begin
    if i > 0 then
    begin
      ExchangeItems(i - 1, i);
      ComboBox1.ItemIndex := i - 1;
      ComboBox1Change(Sender);
    end;
  end
  else if Button = btPrev then
  begin
    if i < ComboBox1.Items.Count - 1 then
    begin
      ExchangeItems(i, i + 1);
      ComboBox1.ItemIndex := i + 1;
      ComboBox1Change(Sender);
    end;
  end;
  BarImage1.BarEnabled := True;
  Label1.Caption := 'o[R[h (' + IntToStr(ComboBox1.ItemIndex + 1) +
                                 ' of ' + IntToStr(ComboBox1.Items.Count) + ')';
end;

procedure TFrameForm.UpDown11MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Abs(UpDown11.Position) > 1000 then
  begin
    UpDown11.Tag := 1;
    UpDown11.Position := 0;
  end;
end;

procedure TFrameForm.ExchangeItems(I, J: Integer);
begin
  ComboBox1.Items.Exchange(I, J);
  ComboBox7.Items.Exchange(I, J);
  ComboBox8.Items.Exchange(I, J);
end;

function TFrameForm.SCompare(I, J: Integer): Integer;
begin
  Result := AnsiCompareText(SortBox.Items.Strings[I],
                            SortBox.Items.Strings[J]) * SortOrder;
end;

procedure TFrameForm.QuickSort(L, R: Integer);
var
  I, J, P: Integer;
begin
  repeat
    I := L;
    J := R;
    P := (L + R) shr 1;
    repeat
      while SCompare(I, P) < 0 do Inc(I);
      while SCompare(J, P) > 0 do Dec(J);
      if I <= J then
      begin
        ExchangeItems(I, J);
        if P = I then
          P := J
        else if P = J then
          P := I;
        Inc(I);
        Dec(J);
      end;
    until I > J;
    if L < J then QuickSort(L, J);
    L := I;
  until I >= R;
end;

procedure TFrameForm.Button13Click(Sender: TObject);
var
  re: Integer;
begin
  if (ComboBox1.Items.Count < 2) or (ComboBox1.ItemIndex = -1) then
    Exit;

  SortForm := TSortForm.Create(Self);

  re := SortForm.ShowModal;

  SortForm.Free;

  if re <> mrOk then
    Exit;

  BarImage1.BarEnabled := False;
  QuickSort(0, ComboBox1.Items.Count - 1);
  ComboBox1.ItemIndex := 0;
  ComboBox7.ItemIndex := 0;
  ComboBox8.ItemIndex := 0;
  BarImage1.CommentUp := ComboBox7.Text;
  BarImage1.CommentDown := ComboBox8.Text;
  BarImage1.Code := ComboBox1.Text;
  BarImage1.BarEnabled := True;
  OldIndex := ComboBox1.ItemIndex;
  DispCheck;
end;

procedure TFrameForm.BarImage1ChangedCode(Sender: TObject; Watch: Boolean);
var
  i, j: Integer;
begin
  if Watch = False then
    Exit;

  { Rgčĕ\B}
  BarImage1.BarEnabled := False;
  BarImage1.CommentUp := '';
  BarImage1.CommentDown := '';
  BarImage1.BarEnabled := True;

  j := -1;
  for i := 0 to ComboBox1.Items.Count - 1 do
  begin
    if ComboBox1.Items.Strings[i] = BarImage1.Code then
    begin
      j := i;
      Break;
    end;
  end;

  if j = -1 then
  begin
    if ComboBox1.Items.Count = 0 then
    begin
      ComboBox1.Items.Add(BarImage1.Code);
      ComboBox1.ItemIndex := 0;
      ComboBox7.Items.Add(BarImage1.CommentUp);
      ComboBox7.ItemIndex := 0;
      ComboBox8.Items.Add(BarImage1.CommentDown);
      ComboBox8.ItemIndex := 0;
    end
    else
    begin
      ComboBox1.Items.Insert(OldIndex + 1, BarImage1.Code);
      ComboBox1.ItemIndex := OldIndex + 1;
      ComboBox7.Items.Insert(OldIndex + 1, BarImage1.CommentUp);
      ComboBox7.ItemIndex := OldIndex + 1;
      ComboBox8.Items.Insert(OldIndex + 1, BarImage1.CommentDown);
      ComboBox8.ItemIndex := OldIndex + 1;
    end;
  end
  else
  begin
    ComboBox1.ItemIndex := j;
    ComboBox7.ItemIndex := j;
    ComboBox8.ItemIndex := j;
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Items.Strings[j];
    BarImage1.CommentDown := ComboBox8.Items.Strings[j];
    BarImage1.BarEnabled := True;
  end;

  OldIndex := ComboBox1.ItemIndex;
  DispCheck;
end;

procedure TFrameForm.N01Click(Sender: TObject);
begin
  BarImage1.Angle := 0;
end;

procedure TFrameForm.N901Click(Sender: TObject);
begin
  BarImage1.Angle := 90;
end;

procedure TFrameForm.N1801Click(Sender: TObject);
begin
  BarImage1.Angle := 180;
end;

procedure TFrameForm.N2701Click(Sender: TObject);
begin
  BarImage1.Angle := 270;
end;

procedure TFrameForm.Help1Click(Sender: TObject);
var
  FileName: String;
begin
  FileName := Application.ExeName;
  FileName := ExtractFilePath(FileName) + 'Readme.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.PopupMenu1Popup(Sender: TObject);
begin
  N01.Checked := False; N901.Checked := False;
  N1801.Checked := False; N2701.Checked := False; CtrlF51.Checked := False;
  if BarImage1.BarPicture = picBMP then
  begin
    T1.Enabled := True;
    if BarImage1.Angle = 90 then N901.Checked := True
    else if BarImage1.Angle = 180 then N1801.Checked := True
    else if BarImage1.Angle = 270 then N2701.Checked := True
    else N01.Checked := True;
    if BarImage1.Reverse = True then CtrlF51.Checked := True;
  end
  else
  begin
    T1.Enabled := False;
    N01.Checked := True;
  end;
end;

procedure TFrameForm.CtrlF51Click(Sender: TObject);
begin
  if CtrlF51.Checked = True then
    BarImage1.Reverse := False
  else
    BarImage1.Reverse := True;
end;

procedure TFrameForm.Button14Click(Sender: TObject);
begin
  if CheckBox3.Checked = True then
    BarImage1.ClipWatch := False; // NbvĎ@\ꎞIɒ~ĂB

  DataListForm := TDataListForm.Create(Self);

  DataListForm.ShowModal;

  DataListForm.Free;

  if ComboBox1.Items.Count = 0 then // f[^Ȃꍇ
    Button14.Tag := -1
  else if Button14.Tag > ComboBox1.Items.Count - 1 then
    Button14.Tag := ComboBox1.Items.Count - 1;

  ComboBox1.ItemIndex := Button14.Tag;
  OldIndex := ComboBox1.ItemIndex + 1; // ComboBox1, 7, 8 ̓eĕ\ׂ̑[u
  ComboBox1Change(Sender);
  Button14.Tag := 0;

  if CheckBox3.Checked = True then
    BarImage1.ClipWatch := True; // NbvĎ@\ĊJB
end;

procedure TFrameForm.N4Click(Sender: TObject);
begin
  BarSizeForm := TBarSizeForm.Create(Self);

  BarSizeForm.ShowModal;

  BarSizeForm.Free;
end;

procedure TFrameForm.FormCreate(Sender: TObject);
begin
  DropTextTarget1.Register(ScrollBox1);
  DropTextTarget2.Register(Panel2);
end;

procedure TFrameForm.FormDestroy(Sender: TObject);
begin
  DropTextTarget2.UnregisterAll;
  DropTextTarget1.UnregisterAll;
end;

procedure TFrameForm.DropTextTarget1Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
var
  i, j: Integer;
  S: String;
begin
  S := DropTextTarget1.Text;
  if S = '' then
    Exit;

  { ܂Rgĕ\B}
  BarImage1.BarEnabled := False;
  BarImage1.CommentUp := '';
  BarImage1.CommentDown := '';
  BarImage1.Code := S;
  BarImage1.BarEnabled := True;

  j := -1;
  for i := 0 to ComboBox1.Items.Count - 1 do
  begin
    if ComboBox1.Items.Strings[i] = S then
    begin
      j := i;
      Break;
    end;
  end;

  if j = -1 then
  begin
    if ComboBox1.Items.Count = 0 then
    begin
      ComboBox1.Items.Add(S);
      ComboBox1.ItemIndex := 0;
      ComboBox7.Items.Add(BarImage1.CommentUp);
      ComboBox7.ItemIndex := 0;
      ComboBox8.Items.Add(BarImage1.CommentDown);
      ComboBox8.ItemIndex := 0;
    end
    else
    begin
      ComboBox1.Items.Insert(OldIndex + 1, S);
      ComboBox1.ItemIndex := OldIndex + 1;
      ComboBox7.Items.Insert(OldIndex + 1, BarImage1.CommentUp);
      ComboBox7.ItemIndex := OldIndex + 1;
      ComboBox8.Items.Insert(OldIndex + 1, BarImage1.CommentDown);
      ComboBox8.ItemIndex := OldIndex + 1;
    end;
  end
  else
  begin
    ComboBox1.ItemIndex := j;
    ComboBox7.ItemIndex := j;
    ComboBox8.ItemIndex := j;
    BarImage1.BarEnabled := False;
    BarImage1.CommentUp := ComboBox7.Items.Strings[j];
    BarImage1.CommentDown := ComboBox8.Items.Strings[j];
    BarImage1.BarEnabled := True;
  end;

  OldIndex := ComboBox1.ItemIndex;
  DispCheck;
end;

procedure TFrameForm.DropTextTarget2Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
var
  i: Integer;
  S: String;
begin
  S := DropTextTarget2.Text;
  if S = '' then
    Exit;

  i := ComboBox1.ItemIndex;

  if (Point.X < 236) and (Point.Y >= 104) and (Point.Y < 152)
     and (ComboBox1.Items.Count > 0) then
  begin
    ComboBox7.Items.Strings[i] := S;
    ComboBox7.ItemIndex := i;
    BarImage1.CommentUp := S;
  end
  else if (Point.X < 236) and (Point.Y >= 152) and (Point.Y < 198)
     and (ComboBox1.Items.Count > 0) then
  begin
    ComboBox8.Items.Strings[i] := S;
    ComboBox8.ItemIndex := i;
    BarImage1.CommentDown := S;
  end
  else
  begin
    DropTextTarget1.Text := S;
    DropTextTarget1Drop(Sender, ShiftState, Point, Effect);
  end;
end;

procedure TFrameForm.BarImage1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    DragPoint := Point(X, Y);
end;

procedure TFrameForm.BarImage1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Shift <> [ssLeft]) or (BarImage1.Picture.Graphic = Nil) then
    Exit;

  if (Abs(X - DragPoint.X) < Mouse.DragThreshold) and
     (Abs(Y - DragPoint.Y) < Mouse.DragThreshold) then
    Exit;

  if BarImage1.Picture.Graphic is TMetafile then
  begin
    DropMetaSource1.Metafile.Assign(BarImage1.Picture.Graphic);
    DropMetaSource1.Execute; // Do it here - dragging from BarImage1.
  end
  else
  begin
    DropBMPSource1.Bitmap.Assign(BarImage1.Picture.Graphic);
    DropBMPSource1.Execute; // Do it here - dragging from BarImage1.
  end;
end;

procedure TFrameForm.N3Click(Sender: TObject);
var
  FileName: String;
begin
  FileName := Application.ExeName;
  FileName := ExtractFilePath(FileName) + 'OnePoint.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

function TFrameForm.Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
begin
  Result := False;
  if MemStream.Size = 0 then
    Exit;
  Data := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, MemStream.Size);
  try
    DataPtr := GlobalLock(Data);
    try
      MemStream.Position := 0;
      MemStream.ReadBuffer(DataPtr^, MemStream.Size);
      MemStream.Position := 0;
    finally
      GlobalUnlock(Data);
    end;
    Clipboard.SetAsHandle(Format, Data);
  except
    GlobalFree(Data);
    raise;
  end;
  Result := True;
end;

procedure TFrameForm.Panel9MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  g: Integer;
begin
  g := 0;
  if ssLeft in Shift then       // }EX̍{^ꂽB
  begin
    if ssShift in Shift then
      g := -10
    else if ssCtrl in Shift then
      g := -5
    else if ssAlt in Shift then
      g := -2
    else
      g := -1;
  end
  else if ssRight in Shift then // }EX̉E{^ꂽB
  begin
    if ssShift in Shift then
      g := 10
    else if ssCtrl in Shift then
      g := 5
    else if ssAlt in Shift then
      g := 2
    else
      g := 1;
  end;

  startx := startx + g;
  if startx < 0 then
    startx := 0
  else if startx > 2000 then
    startx := 2000;
  Panel9.Caption := 'X = ' + IntToStr(startx);
end;

procedure TFrameForm.Panel10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  g: Integer;
begin
  g := 0;
  if ssLeft in Shift then       // }EX̍{^ꂽB
  begin
    if ssShift in Shift then
      g := -10
    else if ssCtrl in Shift then
      g := -5
    else if ssAlt in Shift then
      g := -2
    else
      g := -1;
  end
  else if ssRight in Shift then // }EX̉E{^ꂽB
  begin
    if ssShift in Shift then
      g := 10
    else if ssCtrl in Shift then
      g := 5
    else if ssAlt in Shift then
      g := 2
    else
      g := 1;
  end;

  starty := starty + g;
  if starty < 0 then
    starty := 0
  else if starty > 2000 then
    starty := 2000;
  Panel10.Caption := 'Y = ' + IntToStr(starty);
end;

{ ݂̎擾ĕԂ֐łB}

function TFrameForm.CollectPaperInfo: TPaperInfo;
var
  Device, Driver, Port: array[0..512] of Char;
  hDev: THandle;     // DevMode ̃nh
  pDev: PDEVICEMODE; // DevMode ւ̃|C^
  PI: Integer;
begin
  // DPIl擾
  Result.DPI.cx := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
  Result.DPI.cy := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
  // \̈擾
  Result.PrintableArea.Width := GetDeviceCaps(Printer.Handle, HORZRES);
  Result.PrintableArea.Height := GetDeviceCaps(Printer.Handle, VERTRES);
  Result.MMPrintableArea.Width := Result.PrintableArea.Width / Result.DPI.cx * 25.4;
  Result.MMPrintableArea.Height := Result.PrintableArea.Height / Result.DPI.cy * 25.4;
  // TCY擾
  Result.PaperSize.Width := GetDeviceCaps(Printer.Handle, PHYSICALWIDTH);
  Result.PaperSize.Height := GetDeviceCaps(Printer.Handle, PHYSICALHEIGHT);
  Result.MMPaperSize.Width := Result.PaperSIze.Width / Result.DPI.cx * 25.4;
  Result.MMPaperSize.Height := Result.PaperSIze.Height / Result.DPI.cy * 25.4;
  // ]擾AvZ
  Result.LeftMargin := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETX);
  Result.TopMargin := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETY);
  Result.RightMargin := Result.PaperSize.Width - Result.PrintableArea.Width - Result.LeftMargin;
  Result.BottomMargin := Result.PaperSize.Height - Result.PrintableArea.Height - Result.TopMargin;
  // ]1C`%l
  // ̒l菬l]ƂĐݒ肷鎖́Ao܂B
  PI := Result.LeftMargin * 100;
  if (PI mod Result.DPI.cx) = 0 then
    PI := PI div Result.DPI.cx
  else
    PI := PI div Result.DPI.cx + 1;
  Result.PILeftMargin := TPercent(PI);
  PI := Result.TopMargin * 100;
  if (PI mod Result.DPI.cy) = 0 then
    PI := PI div Result.DPI.cy
  else
    PI := PI div Result.DPI.cy + 1;
  Result.PITopMargin := TPercent(PI);
  PI := Result.RightMargin * 100;
  if (PI mod Result.DPI.cx) = 0 then
    PI := PI div Result.DPI.cx
  else
    PI := PI div Result.DPI.cx + 1;
  Result.PIRightMargin := TPercent(PI);
  PI := Result.BottomMargin * 100;
  if (PI mod Result.DPI.cy) = 0 then
    PI := PI div Result.DPI.cy
  else
    PI := PI div Result.DPI.cy + 1;
  Result.PIBottomMargin := TPercent(PI);
  Result.MMLeftMargin := Result.LeftMargin / Result.DPI.cx * 25.4;
  Result.MMTopMargin :=  Result.TopMargin / Result.DPI.cy * 25.4;
  Result.MMRightMargin := Result.RightMargin / Result.DPI.cx * 25.4;
  Result.MMBottomMargin :=  Result.BottomMargin / Result.DPI.cy * 25.4;

  // XP[t@N^擾
  Printer.GetPrinter(Device, Driver, Port, hDev);
  pDev := GlobalLock(hDev);
  try
    if (pDev.dmFields and DM_SCALE) <> 0 then
      Result.ScaleFactor := pDev.dmScale
    else
      Result.ScaleFactor := 100;
  finally
    GlobalUnlock(hDev);
  end;

  Result.TrueMMPrintableArea.Width := Result.MMPrintableArea.Width * Result.ScaleFactor / 100;
  Result.TrueMMPrintableArea.Height := Result.MMPrintableArea.Height * Result.ScaleFactor / 100;
  Result.TrueMMPaperSize.Width := Result.MMPaperSize.Width * Result.ScaleFactor / 100;
  Result.TrueMMPaperSize.Height := Result.MMPaperSize.Height * Result.ScaleFactor / 100;
  Result.TrueMMLeftMargin := Result.MMLeftMargin * Result.ScaleFactor / 100;
  Result.TrueMMTopMargin := Result.MMTopMargin * Result.ScaleFactor / 100;
  Result.TrueMMRightMargin := Result.MMRightMargin * Result.ScaleFactor / 100;
  Result.TrueMMBottomMargin := Result.MMBottomMargin * Result.ScaleFactor / 100;
end;

initialization
  CF_JFIF := RegisterClipboardFormat('JFIF');
  TPicture.RegisterClipboardFormat(CF_JFIF, TJPEGImage);
  RegisterClass(TJPEGImage);

end.
